#include <iostream>
using namespace std;

const int MAXS = 50;

char grille[MAXS][MAXS];
int order[MAXS*MAXS];

void rotateGrille(int size)
{
	char tmp[MAXS][MAXS];

	for(int i=0; i<size; i++)
		for(int j=0; j<size; j++)
			tmp[i][j] = grille[i][j];
 for(int i=0; i<size; i++)
		for(int j=0; j<size; j++)
			grille[j][size-i-1] = tmp[i][j];
}

bool buildOrder(int size)
{
    for(int i=0; i<size*size; i++)
        order[i] = -1;
	int k=0;
	for(int r=0; r<4; r++) {
		for(int i=0; i<size; i++)
			for(int j=0; j<size; j++)
				if (grille[i][j] == '.')
					order[i*size + j] = k++;
		rotateGrille(size);
	}
/*
cout << "k = " << k << endl;
for(int i=0; i<size*size; i++)
cout << order[i] << ' ';
cout << endl;
*/
	for(int i=0; i<size*size; i++)
		if(order[i] == -1)
			return false;
	return true;
}

int main()
{
	int n;
	string cipher;

	cin >> n;
		int gsize = 0;
		for(int i=0; i<n; i++) {
			for(int j=0; j<n; j++) {
				cin >> grille[i][j];
				if (grille[i][j] == '.')
                    gsize++;
			}
		}
		cin >> cipher;
		if (gsize*4 == n*n && buildOrder(n)) {
			string plain = "";
			for(int i=0; i<cipher.length(); i+=n*n) {
				for(int j=0; j<n*n; j++) {
					plain += cipher[i+order[j]];
				}
			}
			cout << plain << endl;
		}
		else
			cout << "invalid grille" << endl;
return 0;
}
